package
{
	import flash.display.Sprite;
	import flash.display.StageAlign;
	import flash.display.StageScaleMode;
	import flash.events.Event;
	import flash.geom.Rectangle;
	
	import starling.core.Starling;
	
	[SWF(frameRate="60")]
	public class Main extends Sprite
	{
		private var _starling:Starling;
		public function Main()
		{
			super();
			
			if(stage)
			{
				stage.scaleMode = StageScaleMode.NO_SCALE;
				stage.align = StageAlign.TOP_LEFT;
			}
			mouseEnabled = mouseChildren = false;
			loaderInfo.addEventListener(Event.COMPLETE, onCompleteLoaderInfo);	
		}
		
		private function onCompleteLoaderInfo(event:Event):void
		{
			Starling.handleLostContext = true;
			//Starling.multitouchEnabled = true;
			_starling = new Starling(TestBox2D, stage);
			_starling.enableErrorChecking = false;
			_starling.showStats = true;
			_starling.start();
			
			stage.addEventListener(Event.RESIZE, onResizeStage, false, int.MAX_VALUE, true);
			stage.addEventListener(Event.DEACTIVATE, onDeactivateStage, false, 0, true);
		}
		
		private function onResizeStage(event:Event):void
		{
			_starling.stage.stageWidth = stage.stageWidth;
			_starling.stage.stageHeight = stage.stageHeight;
			
			const viewPort:Rectangle = _starling.viewPort;
			viewPort.width = stage.stageWidth;
			viewPort.height = stage.stageHeight;
			try
			{
				_starling.viewPort = viewPort;
			}
			catch(error:Error) {}
		}
		
		private function onDeactivateStage(event:Event):void
		{
			_starling.stop();
			stage.addEventListener(Event.ACTIVATE, onActivateStage, false, 0, true);
		}
		
		private function onActivateStage(event:Event):void
		{
			stage.removeEventListener(Event.ACTIVATE, onActivateStage);
			_starling.start();
		}
	}
}